std::experimental::fundamentals_v1::_Optional_base< _Tp, false > Class Template Reference
Experimental » Optional values

`#include <optional>`

## Public Member Functions

| _Optional_base (_Optional_base &&__other) noexcept(is_nothrow_move_constructible< _Tp >())
| _Optional_base (const _Optional_base &__other)
template<typename... _Args>
constexpr | _Optional_base (in_place_t, _Args &&... __args)
template<typename _Up , typename... _Args, enable_if_t< is_constructible< _Tp, initializer_list< _Up > &, _Args &&... >::value, int > ...>
constexpr | _Optional_base (in_place_t, initializer_list< _Up > __il, _Args &&... __args)
constexpr | _Optional_base (nullopt_t) noexcept
_Optional_base & | operator= (_Optional_base &&__other) noexcept(__and_< is_nothrow_move_constructible< _Tp >, is_nothrow_move_assignable< _Tp > >())
_Optional_base & | operator= (const _Optional_base &__other)

## Protected Member Functions

template<typename... _Args>
void | _M_construct (_Args &&... __args) noexcept(is_nothrow_constructible< _Stored_type, _Args... >())
void | _M_destruct ()
constexpr const _Tp & | _M_get () const noexcept
_Tp & | _M_get () noexcept
constexpr bool | _M_is_engaged () const noexcept
void | _M_reset ()

## Detailed Description

template<typename _Tp>
class std::experimental::fundamentals_v1::_Optional_base< _Tp, false >

Partial specialization that is exactly identical to the primary template save for not providing a destructor, to fulfill triviality requirements.

Definition at line 345 of file optional.

## Constructor & Destructor Documentation

## _Optional_base() [1/6]

template<typename _Tp >

constexpr std::experimental::fundamentals_v1::_Optional_base< _Tp, false >::_Optional_base | ( |  | ) |

inline constexpr noexcept

Definition at line 351 of file optional.

## _Optional_base() [2/6]

template<typename _Tp >

constexpr std::experimental::fundamentals_v1::_Optional_base< _Tp, false >::_Optional_base | ( | nullopt_t |  | ) |

inline constexpr noexcept

Definition at line 354 of file optional.

## _Optional_base() [3/6]

template<typename _Tp >
template<typename... _Args>

constexpr std::experimental::fundamentals_v1::_Optional_base< _Tp, false >::_Optional_base | ( | in_place_t | ,
|  | _Args &&... | __args
| ) |  |

inline explicit constexpr

Definition at line 358 of file optional.

## _Optional_base() [4/6]

template<typename _Tp >
template<typename _Up , typename... _Args, enable_if_t< is_constructible< _Tp, initializer_list< _Up > &, _Args &&... >::value, int > ...>

constexpr std::experimental::fundamentals_v1::_Optional_base< _Tp, false >::_Optional_base | ( | in_place_t | ,
|  | initializer_list< _Up > | __il,
|  | _Args &&... | __args
| ) |  |

inline explicit constexpr

Definition at line 366 of file optional.

## _Optional_base() [5/6]

template<typename _Tp >

std::experimental::fundamentals_v1::_Optional_base< _Tp, false >::_Optional_base | ( | const _Optional_base< _Tp, false > & | __other | ) |

inline

Definition at line 372 of file optional.

## _Optional_base() [6/6]

template<typename _Tp >

std::experimental::fundamentals_v1::_Optional_base< _Tp, false >::_Optional_base | ( | _Optional_base< _Tp, false > && | __other | ) |

inline noexcept

Definition at line 378 of file optional.

## Member Function Documentation

## _M_construct()

template<typename _Tp >
template<typename... _Args>

void std::experimental::fundamentals_v1::_Optional_base< _Tp, false >::_M_construct | ( | _Args &&... | __args | ) |

inline protected noexcept

Definition at line 434 of file optional.

## _M_destruct()

template<typename _Tp >

void std::experimental::fundamentals_v1::_Optional_base< _Tp, false >::_M_destruct | ( |  | ) |

inline protected

Definition at line 443 of file optional.

## _M_get() [1/2]

template<typename _Tp >

constexpr const _Tp & std::experimental::fundamentals_v1::_Optional_base< _Tp, false >::_M_get | ( |  | ) | const

inline constexpr protected noexcept

Definition at line 429 of file optional.

## _M_get() [2/2]

template<typename _Tp >

_Tp & std::experimental::fundamentals_v1::_Optional_base< _Tp, false >::_M_get | ( |  | ) |

inline protected noexcept

Definition at line 425 of file optional.

## _M_is_engaged()

template<typename _Tp >

constexpr bool std::experimental::fundamentals_v1::_Optional_base< _Tp, false >::_M_is_engaged | ( |  | ) | const

inline constexpr protected noexcept

Definition at line 421 of file optional.

## _M_reset()

template<typename _Tp >

void std::experimental::fundamentals_v1::_Optional_base< _Tp, false >::_M_reset | ( |  | ) |

inline protected

Definition at line 450 of file optional.

## operator=() [1/2]

template<typename _Tp >

_Optional_base & std::experimental::fundamentals_v1::_Optional_base< _Tp, false >::operator= | ( | _Optional_base< _Tp, false > && | __other | ) |

inline noexcept

Definition at line 401 of file optional.

## operator=() [2/2]

template<typename _Tp >

_Optional_base & std::experimental::fundamentals_v1::_Optional_base< _Tp, false >::operator= | ( | const _Optional_base< _Tp, false > & | __other | ) |

inline

Definition at line 386 of file optional.

## Member Data Documentation

## _M_empty

template<typename _Tp >

_Empty_byte std::experimental::fundamentals_v1::_Optional_base< _Tp, false >::_M_empty

Definition at line 460 of file optional.

## _M_payload

template<typename _Tp >

_Stored_type std::experimental::fundamentals_v1::_Optional_base< _Tp, false >::_M_payload

Definition at line 461 of file optional.

The documentation for this class was generated from the following file:

- optional